import { wm, wdata } from './windowManager';
import { wait, toP } from './utils'
import { BrowserWindow, screen } from 'electron';

export default async function displayCrashScreen() {
  const bwdata = { ...wdata };
  const win = wm.create({
    w: 40,
    h: 40,
    whp: true,
    onCreate: (win: BrowserWindow) => {
      win.loadURL(`http://localhost:${process.nfenv.serverPort}/screens/crash/index.html`);
    },
    onClose: function () {
      process.exit(1)
    }
  });
  const button = wm.create({
    w: 10,
    h: 5,
    whp: true,
    noBorder: true,
    noBackground: true,
    onCreate: (win: BrowserWindow) => {
      win.loadURL(`http://localhost:${process.nfenv.serverPort}/screens/crash/exit.html`);
    },
  });
  await wait(300);
  Object.keys(bwdata).forEach(async (id) => {
    bwdata[id].win.destroy(); // Note: We dont use wm.destroy(...) so ...onDestroy wont get called and cause trouble
  });
  console.log('[nfcrash] Deleted all windows');
  const { width: sw, height: sh } = screen.getPrimaryDisplay().bounds;
  const { height: csh, y: csy } = wdata[win].win.getBounds();
  await wait(100);
  // Gives more control on the padding
  //                      vvvvvvvvvv padding between the screen and exit button
  const yTo = csy + csh + toP(sh, 6);
  const xTo = toP(sw, 50);
  wm.move({ id: button, y: yTo, x: xTo, fromCenter: true });
  wm.follow.start(button, win);
};